require 'date'

module ChainedValidation
  module Rules
    class IsDate

      def initialize(params)
        @object = params.fetch(:object)
      end

      def perform
        ChainedValidation::Validation.new({ is_date: { object: @object, result: is_date_valid? }})
      end

      private

      def is_date_valid?
        Date.parse(@object)
        return true
      rescue ArgumentError
        return false
      end
    end
  end
end
