require 'json'

module ChainedValidation
  module Rules
    class IsJson
      def initialize(params)
        @object = params.fetch(:object)
      end

      def perform
        ChainedValidation::Validation.new(is_json: { object: @object, result: is_json_valid? })
      end

      private

      def is_json_valid?
        JSON.parse(@object)
        return true
      rescue JSON::ParserError
        return false
      end
    end
  end
end
