module ChainedValidation
  module Rules
    class Rg
      def initialize(params)
        @object = params.fetch(:object)
      end

      def perform
        ChainedValidation::Validation.new(rg: { object: @object, result: is_rg_valid? })
      end

      private

      def is_rg_valid?
        rg = @object.split("")
        base = 2 
        total = 0

        rg.first(8).each do |n| 
          total += n.to_i * base
          base+=1
        end
          
        vd = 11 - total % 11 
        return  (rg[rg.length - 1].to_i == vd)
      end
    end
  end
end
