module ChainedValidation
  module Rules
    class Roman
      def initialize(params)
        @object = params.fetch(:object)
      end

      def perform
        ChainedValidation::Validation.new(roman: { object: @object, result: is_roman? })
      end

      private

      def is_roman?
        # Based on Regular Expression Grabbag in the O'Reilly Perl Cookbook, #6.23
        regexp = /^M*(D?C{0,3}|C[DM])(L?X{0,3}|X[LC])(V?I{0,3}|I[VX])$/i
        regexp === @object.to_s
      end
    end
  end
end
